///////////////////////NEDbook fw v.0.3  //////////////////////////////
///////////////////////5.7.2023 ///////////////////////////////////////
///////////////////www.arze.cz/////////////////////////////////////////
#include <SPI.h>      //knihovna pro SPI
#include <SD.h>       //knihovna pro SD kartu
#include <Wire.h>     //knihovna pro I2C
#include <WiFiNINA.h> //knihovna pro analogové čtení

byte klavesa = 0x00;      //načtená klávesa z klávesnice
char INklav[80];          //pole max. 80 znaků načtených z klávesnice
String INklavesnice;      //řetězec znaků načtených z klávesnice
String BASICpole[1000];   //pole 1000 řádků
int promenne[25];         //řetězec proměnných
int q;                    //proměnná pro číslo řádku pro skok v programu
int kde;                  //ukazatel kde jsme v programu = 1-hlavní smyčka
byte sekundy, minuty, hodiny, denVt, den, mesic, rok; //proměnné RTC

int GPUx1 = 0;  //proměnná pro grafiku GPU - souřadnice X1
int GPUy1 = 0;  //proměnná pro grafiku GPU - souřadnice Y1
int GPUx2 = 0;  //proměnná pro grafiku GPU - souřadnice X2
int GPUy2 = 0;  //proměnná pro grafiku GPU - souřadnice Y2
int GPUr = 0;   //proměnná pro grafiku GPU - poloměr kruhu

#define LED 0x22        //I2C adresa LED - dekadicky 34
#define RTC 0x68        //I2C adresa RTC
#define KLAVESNICE 0x01 //I2C adresa klávesnice

#define GPU Serial1     //GPU na Serial1

const int CS_SD_INT = 10;         //CS interní SD karty
const int CS_SD_EXT = 9;          //CS externí SD karty

Sd2Card card;
SdVolume volume;
SdFile root;

// konverze BCD do dekadického čísla
byte BCDdoDEC(byte val)
{
  return( (val/16*10) + (val%16) );
}

// konverze desítkového čísla do BCD
byte DECdoBCD(byte val)
{
  return( (val/10*16) + (val%10) );
}

/////////////////////////////po spuštění///////////////////////////////////////////////////////////////////////////////////////
void setup() 
  {
    Wire.begin();           //start I2C
    Wire.beginTransmission(LED);        //zhasni LED
    Wire.write(0x00);                   //zhasni LED
    Wire.endTransmission();             //zhasni LED
    Wire.beginTransmission(0x20);       //vynuluj porty LPT
    Wire.write(0x00);                   //vynuluj porty LPT
    Wire.endTransmission();             //vynuluj porty LPT
    Wire.beginTransmission(0x21);       //vynuluj porty LPT
    Wire.write(0x00);                   //vynuluj porty LPT
    Wire.endTransmission();             //vynuluj porty LPT
    GPU.begin(115200);      //rychlost odesílání do GPU
    Serial.begin(9600);
    delay(3000);            //počkej 5s
    pinMode(CS_SD_INT, OUTPUT);       //nastavení CS_SD_INT jako výstup
    pinMode(CS_SD_EXT, OUTPUT);       //nastavení CS_SD_EXT jako výstup
    digitalWrite(CS_SD_INT, HIGH);    //nastavení CS_SD_INT na log. 1 - SD INT neaktivní
    digitalWrite(CS_SD_EXT, HIGH);    //nastavení CS_SD_EXT na log. 1 - SD EXT neaktivní
    GPUsmaz();              //smaž obrazovku
    GPU.println(F("NEDbook v.0.3                     www.arze.cz                             2023"));
    GPU.println(F("F1 - napoveda , F2 - nastaveni , F3 - mandelbrot"));
  }

void loop() 
  {
    kde = 1;          //ukazatel kde jsme v programu na 1 - hlavní smyčka
    GPU.print("?:");

    klavesnice();   //vstup z klávesnice
    vyber();
  }

///////////////////////podprogram vstupu klávesy z klávesnice////////////////////////////////////////////////////////////////////
void klavesniceKLAVESA()
  {
    klavesa = 0x00;  //vynuluj klávesu
    
    do
    {    
      Wire.requestFrom(KLAVESNICE,1);  // přijmy jeden byte z klávesnice

      while (Wire.available())  // pokud jsou přijata data
      {
        byte c = Wire.read();   // přečti data
        if (c != 0)             // pokud jsou přijata platná data
        {
            klavesa = c;        //zkopíruj byte do proměnné klavesa
        }
      }
    }while(klavesa < 0x00);        //opakuj dokud nebude stisknuta klávesa
  }

///////////////////////podprogram vstupu klávesy ESC z klávesnice////////////////////////////////////////////////////////////////////
void klavesniceESC()
  {
    klavesa = 0x00;  //vynuluj klávesu
       
    Wire.requestFrom(KLAVESNICE,1);  // přijmy jeden byte z klávesnice

    while (Wire.available())  // pokud jsou přijata data
     {
      byte c = Wire.read();   // přečti data
         if (c != 0)             // pokud jsou přijata platná data
          {
            klavesa = c;        //zkopíruj byte do proměnné klavesa
            if(klavesa == 145)  //pokud byl stisknut ESC
              {
                q=999;
                GPU.println();
                loop();         //vrať se do smyčky
              }
          }
      }
    
  }

////////////////////podprogram vstupu řádku z klávesnice///////////////////////////////////////////////////////////////////////////
void klavesnice()
  {
    int x = 0;   //proměnná počtu znaků z klávesnice

    memset(INklav, 0x00, sizeof(INklav));   //smaž proměnnou vstupního řádku

    do{
        klavesniceKLAVESA();    //načti jeden znak z klávesnice
        if(klavesa > 0x00 && klavesa >= 32 && klavesa <= 126)  //pokud je stisknutý tisknutelný znak
          {
            char kl = klavesa;  //hex do char
            INklav[x] = kl;     //ulož znak do pole
            GPU.print(kl);      //vypiš znak
            x++;  
          }
        else if(klavesa == 159 && kde == 1) //pokud byl stisknut F1 v hlavní smyčce
          {
            F1loop();     //skoč do hlavní nápovědy 
          }
        else if(klavesa == 160 && kde == 1) //pokud byl stisknut F2 v hlavní smyčce
          {
            F2loop();     //skoč do nastavení systému
          }
        else if(klavesa == 161 && kde == 1) //pokud byl stisknut F3 v hlavní smyčce
          {
            F3loop();     //skoč do podprogramu mandelbrot
          }
        else if(klavesa == 150) //šipka v levo
          {
            GPU.write(0x1B);    //ESC kód
            GPU.print("[1D");
            x--;
          }
        else if(klavesa == 151) //šipka vpravo
          {
            GPU.write(0x1B);    //ESC kód
            GPU.print("[1C");
            x++;
          }

    }while(klavesa != 13);  //opakuj dokud nebyl stisknut enter

    INklavesnice = INklav; //převeď obsah pole do řetězce
  }

////////////////////////////////////výběr příkazu///////////////////////////////////////////////////////////////////////////////////////
void vyber()
  {
    if(INklavesnice == "clr") //příkaz "clr"
      {
        GPUsmaz();      //smaž LCD
      }
      else if(INklav[0] >= 48 && INklav[0] <= 57 && INklav[1] == 32)  //pokud je první znak číslo a druhý znak mezera pak ulož BASIC řádek
        {
          ulozPRIKAZ();   //ulož BASIC řádek 1-9
        }
      else if(INklav[0] >= 48 && INklav[0] <= 57 && INklav[1] >= 48 && INklav[1] <= 57 && INklav[2] == 32)  //pokud je 1. a 2. znak číslo a 3. mezera pak ulož BASIC řádek
        {
          ulozPRIKAZ();   //ulož BASIC řádek 10 - 99
        }
      else if(INklav[0] >= 48 && INklav[0] <= 57 && INklav[1] >= 48 && INklav[1] <= 57 && INklav[2] >= 48 && INklav[2] <= 57 && INklav[3] == 32) //pokud je 1. až 3. znak číslo a 4. mezera pak ulož BASIC řádek
        {
          ulozPRIKAZ();   //ulož BASIC řádek 100 - 999
        }
      else if(INklav[0] >= 48 && INklav[0] <= 57 && INklav[1] == 61)  //pokud je první znak číslo a druhý znak = pak načti BASIC řádek
        {
          GPU.println();    //nový řádek
          nactiPRIKAZ();    //načti BASIC řádek 1-9
        }
      else if(INklav[0] >= 48 && INklav[0] <= 57 && INklav[1] >= 48 && INklav[1] <= 57 && INklav[2] == 61)  //pokud je 1. a 2. znak číslo a 3. = pak načti BASIC řádek
        {
          GPU.println();    //nový řádek
          nactiPRIKAZ();    //načti BASIC řádek 10 - 99
        }
      else if(INklav[0] >= 48 && INklav[0] <= 57 && INklav[1] >= 48 && INklav[1] <= 57 && INklav[2] >= 48 && INklav[2] <= 57 && INklav[3] == 61) //pokud je 1. až 3. znak číslo a 4. = pak načti BASIC řádek
        {
          GPU.println();    //nový řádek
          nactiPRIKAZ();    //načti BASIC řádek 100 - 999
        }
      else if(INklavesnice == "list")
      {
        GPU.println();    //nový řádek
        list();           //vypiš paměť příkazů
      }
      else if(INklavesnice == "run")
      {
        GPU.println();
        beh();              //běh programu z paměti příkazů
      }
      else if(INklavesnice == "ret")
      {
        ret();            //návrat do hlavní smyčky
      }
      else if(INklav[0] == 'j' && INklav[1] == 'm' && INklav[2] == 'p')
      {
        jump();             //skok v programu na řádek - jmp
      }
      else if(INklav[0] == 'd' && INklav[1] == 'e' && INklav[2] == 'l' && INklav[3] == 'a' && INklav[4] == 'y')
      {
        cekej();            //čekání
      }
      else if(INklav[0] == 'c' && INklav[1] == 'a' && INklav[2] == 'r' && INklav[3] == 'a') 
      {
        cara();           //kreslení čáry
      }
      else if(INklav[0] == 'c' && INklav[1] == 't' && INklav[2] == 'v' && INklav[3] == 'e' && INklav[4] == 'r' && INklav[5] == 'e' && INklav[6] == 'c' && INklav[7] == 'p' && INklav[8] == 'l') 
      {
        ctverecPL();           //kreslení plného čtverce
      }
      else if(INklav[0] == 'c' && INklav[1] == 't' && INklav[2] == 'v' && INklav[3] == 'e' && INklav[4] == 'r' && INklav[5] == 'e' && INklav[6] == 'c' && INklav[7] == 'p' && INklav[8] == 'r') 
      {
        ctverecPR();           //kreslení prázdného čtverce
      }
      else if(INklav[0] == 'k' && INklav[1] == 'r' && INklav[2] == 'u' && INklav[3] == 'h' && INklav[4] == 'p' && INklav[5] == 'l') 
      {
        kruhPL();           //kreslení plného kruhu
      }
      else if(INklav[0] == 'k' && INklav[1] == 'r' && INklav[2] == 'u' && INklav[3] == 'h' && INklav[4] == 'p' && INklav[5] == 'r') 
      {
        kruhPR();           //kreslení plného kruhu
      }
      else if(INklav[0] == 'p' && INklav[1] == 'i' && INklav[2] == 'x' && INklav[3] == 'e' && INklav[4] == 'l') 
      {
        pixel();           //kreslení bodu
      }
      else if(INklavesnice == "uptime")
      {
        uptime();            //čas od spuštění
      }
      else if(INklavesnice == "random")
      {
        nahoda();            //vypiš náhodný znak
      }
      else if(INklavesnice == "delete")
      {
        del();            //smaž paměť programu
      }
      else if(INklavesnice == "time")
      {
        nactiRTC();         //načtení času a data z RTC
      }
      else if(INklavesnice == "set rtc")
      {
        nastavRTC();
      }
      else if(INklavesnice == "sd info")
      {
        SDinfo();           //info o SD kartě
      }
      else if(INklavesnice == "sd int ls")
      {
        SDvypisINT();          //výpis z SD karty
      }
      else if(INklavesnice == "sd ext ls")
      {
        SDvypisEXT();          //výpis z SD karty
      }
      else if(INklav[0] == 's' && INklav[1] == 'd' && INklav[2] == ' ' && INklav[3] == 'i' && INklav[4] == 'n' && INklav[5] == 't' && INklav[6] == ' ' && INklav[7] == 's' && INklav[8] == 'a' && INklav[9] == 'v' && INklav[10] == 'e')
      {
        SDsaveINT();           //uložení programu na interní SD kartu - sd int save xxxxxxxxxx
      }
      else if(INklav[0] == 's' && INklav[1] == 'd' && INklav[2] == ' ' && INklav[3] == 'e' && INklav[4] == 'x' && INklav[5] == 't' && INklav[6] == ' ' && INklav[7] == 's' && INklav[8] == 'a' && INklav[9] == 'v' && INklav[10] == 'e')
      {
        SDsaveEXT();           //uložení programu na externí SD kartu - sd ext save xxxxxxxxxx
      }
      else if(INklav[0] == 's' && INklav[1] == 'd' && INklav[2] == ' ' && INklav[3] == 'i' && INklav[4] == 'n' && INklav[5] == 't' && INklav[6] == ' ' && INklav[7] == 'l' && INklav[8] == 'o' && INklav[9] == 'a' && INklav[10] == 'd')
      {
        SDloadINT();           //načtení programu z interní SD karty - sd int load xxxxxxxxxx
      }
      else if(INklav[0] == 's' && INklav[1] == 'd' && INklav[2] == ' ' && INklav[3] == 'e' && INklav[4] == 'x' && INklav[5] == 't' && INklav[6] == ' ' && INklav[7] == 'l' && INklav[8] == 'o' && INklav[9] == 'a' && INklav[10] == 'd')
      {
        SDloadEXT();           //načtení programu z externí SD karty - sd ext load xxxxxxxxxx
      }
      else if(INklav[0] == 's' && INklav[1] == 'd' && INklav[2] == ' ' && INklav[3] == 'i' && INklav[4] == 'n' && INklav[5] == 't' && INklav[6] == ' ' && INklav[7] == 'd' && INklav[8] == 'e' && INklav[9] == 'l')
      {
        SDdelINT();           //smazání souboru na interní SD kartě - sd int del xxxxxxxxxx
      }
      else if(INklav[0] == 's' && INklav[1] == 'd' && INklav[2] == ' ' && INklav[3] == 'e' && INklav[4] == 'x' && INklav[5] == 't' && INklav[6] == ' ' && INklav[7] == 'd' && INklav[8] == 'e' && INklav[9] == 'l')
      {
        SDdelEXT();           //smazání souboru na externí SD kartě - sd ext del xxxxxxxxxx
      }
      else if(INklavesnice == "i2c scan")
      {
        i2c_scan();       //i2c scan
      }
      else if(INklav[0] == 'o' && INklav[1] == 'u' && INklav[2] == 't')
      {
        out();            //výstup na port
      }
       else if(INklav[0] == 'i' && INklav[1] == 'n' && INklav[2] == ' ')
      {
        in();             //vstup z portu
      }
      else if(INklav[0] >= 97 && INklav[0] <= 122 && INklav[1] == '=' && INklav[2] != '=')
      {
        vytvorPROMENOU();   //zapíše proměnnou
      }
      else if(INklav[0] >= 97 && INklav[0] <= 122 && INklav[1] == '=' && INklav[2] == '=')
      {
        vypisPROMENOU();    //vypíše proměnnou
      }
      else if(INklav[1] == '+' &&  INklav[3] == '=')
      {
        secti();           //sčítání proměnných
      }
      else if(INklav[1] == '-' &&  INklav[3] == '=')
      {
        odecti();           //odčítání proměnných
      }
      else if(INklav[1] == '*' &&  INklav[3] == '=')
      {
        nasob();           //násobení proměnných
      }
      else if(INklav[1] == '/' &&  INklav[3] == '=')
      {
        vydel();           //dělení proměnných
      }
      else if(INklav[1] == '&' &&  INklav[3] == '=')
      {
        AND();           //AND proměnných
      }
      else if(INklav[1] == '|' &&  INklav[3] == '=')
      {
        OR();           //AND proměnných
      }
      else if(INklav[1] == '~')
      {
        NOT();           //NOT proměnných
      }
      else if(INklav[1] == '^' &&  INklav[3] == '=')
      {
        XOR();           //XOR proměnných
      }
      else if(INklav[1] == '>' && INklav[2] == '>' && INklav[4] == ' ')
      {
        posunVPRAVO();  //bitový posun vpravo
      }
      else if(INklav[1] == '<' && INklav[2] == '<' && INklav[4] == ' ')
      {
        posunVLEVO();  //bitový posun vlevo
      }
      else if(INklav[0] == '/' && INklav[1] == '/')
      {
        // pokud začíná řádek // pak jde o komentář, nedělej nic
      }
      else if(INklav[0] == 'i' && INklav[1] == 'f')
      {
        podminenySKOK();
      }
      else if(INklav[0] == 'p' && INklav[1] == 'r' && INklav[2] == 'i' && INklav[3] == 'n' && INklav[4] == 't')
      {
        print();
      }
      else if(INklavesnice == "help")
      {
        F1loop();            //nápověda v hlavní smyčce
      }
      else if(INklavesnice == "mandelbrot")
      {
        F3loop();            //mandelbrotova množina
      }
      else if(INklavesnice == "led off")
      {
        Wire.beginTransmission(LED);        //zhasni LED
        Wire.write(0x00);                   //zhasni LED
        Wire.endTransmission();             //zhasni LED
        GPU.println();
      }

      else    //neznámý příkaz
     {
      GPU.println();  //nový řádek
      GPU.print("Neznamy prikaz: ");
      GPU.println(INklav);
      GPU.println(F("Me moznosti jsou omezene, musis pouzit spravny prikaz"));
     }
  }

////////////////////////////////////////////ulož příkaz do pole///////////////////////////////////////////////////////////
void ulozPRIKAZ()
  {
    int x = 0;        //počítadlo smyček
    char cislo[4];    //pole pro uložení čísla řádku 1 - 999

    while(INklav[x] != 32)      //opakuj dokud nebyl načten mezerník
      {
        cislo[x] = INklav[x];
        x++;
      }

    int a = atoi(cislo);          //převeď číslo z pole do int

    BASICpole[a] = INklavesnice;  //ulož zadaný příkaz do pole příkazů
    GPU.println();  //nový řádek
  }

/////////////////////////////////////////načti příkaz z pole/////////////////////////////////////////////////////////////////////////////
void nactiPRIKAZ()
  {
    int x = 0;        //počítadlo smyček
    char cislo[4];    //pole pro uložení čísla řádku 1 - 999

    while(INklav[x] != 61)      //opakuj dokud nebyl načten znak =
      {
        cislo[x] = INklav[x];
        x++;
      }

    int a = atoi(cislo);          //převeď číslo z pole do int

    GPU.println(BASICpole[a]);    //vypiš uložený příkaz z pole příkazů
  }  

///////////////////////////////////////////výpis paměti příkazů///////////////////////////////////////////////////////////
void list()
  {
    int x = 0;      //proměnná čísla řádku z příkazu
    char cislo[4];  //pole pro číslo řádku z příkazu

    for(int a=0; a<1000; a++)    //opakuj pro všech 999 řádků
      {
        cislo[0] = 0;   //vynuluj pole pro číslo řádku z příkazu
        cislo[1] = 0;   //vynuluj pole pro číslo řádku z příkazu
        cislo[2] = 0;   //vynuluj pole pro číslo řádku z příkazu

        String radek = BASICpole[a];    //načti řádek číslo a

        if(radek[0] >= 48 && radek[0] <= 57 && radek[1] == 32)  //pokud je první znak číslo a druhý znak mezera pak
        {
          cislo[0] = radek[0];
        }
      else if(radek[0] >= 48 && radek[0] <= 57 && radek[1] >= 48 && radek[1] <= 57 && radek[2] == 32)  //pokud je 1. a 2. znak číslo a 3. mezera pak
        {
          cislo[0] = radek[0];
          cislo[1] = radek[1];
        }
      else if(radek[0] >= 48 && radek[0] <= 57 && radek[1] >= 48 && radek[1] <= 57 && radek[2] >= 48 && radek[2] <= 57 && radek[3] == 32) //pokud je 1. až 3. znak číslo a 4. mezera pak
        {
          cislo[0] = radek[0];
          cislo[1] = radek[1];
          cislo[2] = radek[2];
        }

        x = atoi(cislo);  //převeď číslo z pole do int

        if(x != 0)    //pokud číslo řádku není 0
          {
           GPU.println(radek);  //vypiš řádek
          }

        }
  }

/////////////////////////////////////////////běh programu z paměti příkazů////////////////////////////////////////////////////
void beh()
  {
    int x = 0;      //proměnná čísla řádku z příkazu
    char cislo[4];  //pole pro číslo řádku z příkazu

    for(q=0; q<1000; q++)    //opakuj pro všech 999 řádků
      {
        cislo[0] = 0;   //vynuluj pole pro číslo řádku z příkazu
        cislo[1] = 0;   //vynuluj pole pro číslo řádku z příkazu
        cislo[2] = 0;   //vynuluj pole pro číslo řádku z příkazu

        String radek = BASICpole[q];    //načti řádek číslo q

        if(radek[0] >= 48 && radek[0] <= 57 && radek[1] == 32)  //pokud je první znak číslo a druhý znak mezera pak
        {
          cislo[0] = radek[0];
        }
        else if(radek[0] >= 48 && radek[0] <= 57 && radek[1] >= 48 && radek[1] <= 57 && radek[2] == 32)  //pokud je 1. a 2. znak číslo a 3. mezera pak
        {
          cislo[0] = radek[0];
          cislo[1] = radek[1];
        }
        else if(radek[0] >= 48 && radek[0] <= 57 && radek[1] >= 48 && radek[1] <= 57 && radek[2] >= 48 && radek[2] <= 57 && radek[3] == 32) //pokud je 1. až 3. znak číslo a 4. mezera pak
        {
          cislo[0] = radek[0];
          cislo[1] = radek[1];
          cislo[2] = radek[2];
        }

        x = atoi(cislo);  //převeď číslo z pole do int

        if(x != 0)    //pokud číslo řádku není 0 = pokud řádek obsahuje příkaz
          {
           if(x > 0 && x < 10)  //pokud je číslo programu jednomístné tj. 1 - 9
            {
              int c=2;    //počítadlo znaků čtení
              int d=0;    //počítadlo znaků zápis
          
            for(int b=0; b<81; b++)  
              {
                INklav[d] = radek[c]; //zkopíruj načtený řádek do proměnné klávesnice posunutý o 2 znaky - smaže označení řádku
                c++;  //zvyš počítadlo
                d++;  //zvyš počítadlo
              }
            INklavesnice = INklav;    //zkopíruj do druhé proměnné
            vyber();                  //proveď příkaz
            }
            else if(x > 9 && x < 100)  //pokud je číslo programu dvojmístné tj. 10 - 99
            {
              int c=3;    //počítadlo znaků čtení
              int d=0;    //počítadlo znaků zápis
          
            for(int b=0; b<81; b++)  
              {
                INklav[d] = radek[c]; //zkopíruj načtený řádek do proměnné klávesnice posunutý o 3 znaky - smaže označení řádku
                c++;  //zvyš počítadlo
                d++;  //zvyš počítadlo
              }
            INklavesnice = INklav;    //zkopíruj do druhé proměnné
            vyber();                  //proveď příkaz
            }
            else if(x > 99 && x < 1000)  //pokud je číslo programu trojmístné tj. 100 - 999
            {
              int c=4;    //počítadlo znaků čtení
              int d=0;    //počítadlo znaků zápis
          
            for(int b=0; b<81; b++)  
              {
                INklav[d] = radek[c]; //zkopíruj načtený řádek do proměnné klávesnice posunutý o 4 znaky - smaže označení řádku
                c++;  //zvyš počítadlo
                d++;  //zvyš počítadlo
              }
            INklavesnice = INklav;    //zkopíruj do druhé proměnné
            vyber();                  //proveď příkaz
            }
          }
        klavesniceESC();    //pokud byl stisknut ESC tak se vrať do hlavní smyčky
      }
  }

///////////////////////////////////////////návrat do hlavní smyčky/////////////////////////////////////////////////////
void ret()
  {
    q=999;
    GPU.println();  //nový řádek
    loop();
  }

////////////////////////////////////////////skok na adresu////////////////////////////////////////////////////////////
void jump()
  {
    char cislo[2];

    cislo[0] = INklav[4];
    cislo[1] = INklav[5];
    cislo[2] = INklav[6];

    q = atoi(cislo);    //převeď číslo z pole do int
    q = q-1;            //nastav ukazatel řádku programu
  }

///////////////////////////////////////////čas od spuštění///////////////////////////////////////////////////////////////
void uptime()
  {
    GPU.print(" ");
    unsigned long ms;   //proměnná pro ms
    int s;              //proměnná pro s
    int s2;             //pomocná proměnná pro s
    int min;            //proměnná pro minuty
    int hod;            //proměnná pro hodiny

    ms = millis();

    if(ms < 1000)       //pokud je čas menší než 1s
      {
        GPU.print(ms);
        GPU.println("ms");
      }
    else if(ms > 1000 && ms < 60000)      //pokud je čas víc než 1s a méně než 1 minuta
      {
        s = ms / 1000;
        GPU.print(s);
        GPU.print("s");
        ms = ms-(s*1000);
        GPU.print(ms);
        GPU.println("ms");
      }
    else if(ms > 60000 && ms < 3600000)   //pokud je čas víc než 1 minuta a méně než 1 hodina
      {
        s = ms / 1000;
        min = s / 60;
        GPU.print(min);
        GPU.print("min, ");
        s2 = min*60;
        s = s - s2;
        GPU.print(s);
        GPU.print("s, ");
        ms = ms - (min*60000)-(s*1000);
        GPU.print(ms);
        GPU.println("ms");
      }
    else if(ms > 3600000)     //pokud je víc než hodina
      {
        Serial.println(ms);
        s2 = ms / 1000;
        min = s2 / 60;
        hod = min / 60;
        GPU.print(hod);
        GPU.print("hod, ");
        Serial.print(hod);
        Serial.print("hod, ");
        min = (ms-(hod*360000))/60000;
        GPU.print(min);
        GPU.print("min, ");
        Serial.print(min);
        Serial.print("min, ");
        s = (ms-(min*60000))/1000;
        GPU.print(s);
        GPU.print("s");
        Serial.print(s);
        Serial.print("s");
        ms = (ms-(s*1000));
        GPU.print(ms);
        GPU.println("ms");
        Serial.print(ms);
        Serial.println("ms");
      }
  }

///////////////////////////////////////////čekání ms/////////////////////////////////////////////////////////////////////
void cekej()
  {
    char pole[15];  //pole času
    int c=6;        //počítadlo
    int d=0;        //počítadlo

    for(int b=0; b<16; b++)  
      {
        pole[d] = INklav[c]; //zkopíruj řádek do proměnné času posunutý o 6 znaků - smaže název příkazu
        c++;  //zvyš počítadlo
        d++;  //zvyš počítadlo
      }
   
    int a = atoi(pole);

    delay(a);   //čekej

    GPU.println();  //nový řádek
  }

//////////////////////////////////////////////náhodný znak//////////////////////////////////////////////////////////////
void nahoda()
  {
    randomSeed(analogRead(A7));
    char x = random(32, 127);
  
    delay(1000);
    GPU.print(x);
  }

//////////////////////////////////////////vymaž paměť programu/////////////////////////////////////////////////////////////////
void del()
  {
    memset(BASICpole, 0x00, sizeof(BASICpole));   //BASICpole[q]
    GPU.println("smazano");  //nový řádek
  }

/////////////////////podprogram čtení času///////////////////////////////////////////////////////////////////////
void nactiRTC() 
  {
    GPU.println();
    cteniDS3231casu(&sekundy, &minuty, &hodiny, &denVt, &den, &mesic, &rok); //čtení času

  if(hodiny<10)
      {
        GPU.print("0");
      }
    GPU.print(hodiny, DEC);
    GPU.print(":");
    if(minuty<10)
      {
        GPU.print("0");
      }
    GPU.print(minuty, DEC);
    GPU.print(":");
    if(sekundy<10)
      {
        GPU.print("0");
      }
    GPU.print(sekundy, DEC);
   
    if(denVt == 1)
        {
          GPU.print("  Pondeli");
        }
        else if(denVt == 2)
        {
          GPU.print("  Utery  ");
        }
        else if(denVt == 3)
        {
          GPU.print("  Streda ");
        }
        else if(denVt == 4)
        {
          GPU.print("  Ctvrtek ");
        }
        else if(denVt == 5)
        {
          GPU.print("  Patek  ");
        }
        else if(denVt == 6)
        {
          GPU.print("  Sobota ");
        }
        else if(denVt == 7)
        {
          GPU.print("  Nedele ");
        }
    GPU.print(" ");
    if(den<10)
      {
        GPU.print("0");
      }
      GPU.print(den,DEC);
      GPU.print(".");
      if(mesic<10)
      {
        GPU.print("0");
      }
      GPU.print(mesic, DEC);
      GPU.print(".20");
      GPU.println(rok, DEC);
  }

void cteniDS3231casu(byte *sekundy, byte *minuty, byte *hodiny, byte *denVt, byte *den, byte *mesic, byte *rok)
  {
    Wire.beginTransmission(RTC);
    Wire.write(0);                         //nastavení ukazatele registrů v DS3231 na 00h
    Wire.endTransmission();
    Wire.requestFrom(RTC, 7);    //čtení 7 bytů z DS3231
    //čtení 7 bytů dat z DS3231 od registru 00h
    *sekundy = BCDdoDEC(Wire.read() & 0x7f);
    *minuty = BCDdoDEC(Wire.read());
    *hodiny = BCDdoDEC(Wire.read() & 0x3f);
    *denVt = BCDdoDEC(Wire.read());
    *den = BCDdoDEC(Wire.read());
    *mesic = BCDdoDEC(Wire.read());
    *rok = BCDdoDEC(Wire.read());
  }

/////////////////////////////////////////////nastavení RTC/////////////////////////////////////////////////////////////////////////////////
void nastavRTC()
  {
    GPUsmaz(); //smaž obrazovku

    GPU.println("Nastaveni RTC");
    GPU.print("aktualni nastaveni: ");
    nactiRTC();
    GPU.println();
    GPU.println("zadej aktualni cas a datum ve formatu:");
    GPU.println("HH MM SS V DD MM RR");
    GPU.println("HH - hodiny, MM - minuty, SS - sekundy");
    GPU.println("V - cislo dne v tydnu");
    GPU.println("DD - den, MM - mesic, RR - rok (posledni dvojcisli)");
    GPU.print("?:");

    klavesnice();

    char ho[2]; //hodiny
    char mi[2]; //minuty
    char se[2]; //sekundy
    char dv[2]; //den v týdnu
    char de[2]; //den
    char me[2]; //měsíc
    char ro[2]; //rok

    ho[0] = INklav[0];
    ho[1] = INklav[1];
    mi[0] = INklav[3];
    mi[1] = INklav[4];
    se[0] = INklav[6];
    se[1] = INklav[7];
    dv[0] = INklav[9];
    de[0] = INklav[11];
    de[1] = INklav[12];
    me[0] = INklav[14];
    me[1] = INklav[15];
    ro[0] = INklav[17];
    ro[1] = INklav[18];

    int Cho = atoi(ho);
    int Cmi = atoi(mi);
    int Cse = atoi(se);
    int Cdv = atoi(dv);
    int Cde = atoi(de);
    int Cme = atoi(me);
    int Cro = atoi(ro);

    nastaveniDS3231(Cse,Cmi,Cho,Cdv,Cde,Cme,Cro);
    GPU.println();
  }

void nastaveniDS3231(byte sekundy, byte minuty, byte hodiny, byte denVt, byte den, byte mesic, byte rok)
  {
    // odeslání dat do DS3231
    Wire.beginTransmission(RTC);
    Wire.write(0);                   // nastavení
    Wire.write(DECdoBCD(sekundy));   // nastavení sekund
    Wire.write(DECdoBCD(minuty));    // nastavení minut
    Wire.write(DECdoBCD(hodiny));    // nastavení hodin
    Wire.write(DECdoBCD(denVt));     // nastavení dne v týdnu (1=sobota, 7=neděle)
    Wire.write(DECdoBCD(den));       // nastavení data
    Wire.write(DECdoBCD(mesic));     // nastavení měsíce
    Wire.write(DECdoBCD(rok));       // nastavení roku (0 to 99)
    Wire.endTransmission();
  }

//////////////////////////////////informace o SD kartě//////////////////////////////////////////////////////////////
void SDinfo()
  {
    GPU.println();
    GPU.println("Interni uloziste:");

    SD.begin(CS_SD_INT);

    if(!card.init(SPI_HALF_SPEED, CS_SD_INT)) 
      {
        GPU.println("Chyba SD karty");
        while (1);
      } 
      else 
      {  
        // vypiš typ karty
        GPU.println();
        GPU.print("Typ karty: ");
        switch (card.type()) 
          {
          case SD_CARD_TYPE_SD1:
            GPU.println("SD1");
            break;
          case SD_CARD_TYPE_SD2:
            GPU.println("SD2");
            break;
          case SD_CARD_TYPE_SDHC:
            GPU.println("SDHC");
            break;
          default:
            GPU.println("neznami");
          }

        if (!volume.init(card)) 
          {
            GPU.println("Nebyl nalezen svazek FAT16/FAT32.\nNaformatuj kartu");
            while (1);
          }

        GPU.print("Clusters: ");
        GPU.println(volume.clusterCount());
        GPU.print("Blocks x Cluster: ");
        GPU.println(volume.blocksPerCluster());

        GPU.print("Total Blocks: ");
        GPU.println(volume.blocksPerCluster() * volume.clusterCount());
        GPU.println();

        uint32_t volumesize;
        GPU.print("Typ svazku: FAT");
        GPU.println(volume.fatType(), DEC);

        volumesize = volume.blocksPerCluster();    // clusters are collections of blocks
        volumesize *= volume.clusterCount();       // we'll have a lot of clusters
        volumesize /= 2;                           // SD card blocks are always 512 bytes (2 blocks are 1KB)
        GPU.print("Velikost svazku (Kb): ");
        GPU.println(volumesize);
        GPU.print("Velikost svazku (Mb): ");
        volumesize /= 1024;
        GPU.println(volumesize);
        GPU.print("Velikost svazku (Gb): ");
        GPU.println((float)volumesize / 1024.0);
      }
  digitalWrite(CS_SD_INT, HIGH);    //nastavení CS_SD_INT na log. 1 - SD INT neaktivní

  GPU.println();
  SD.begin(CS_SD_EXT);
  GPU.println("Externi uloziste:");
  if (!card.init(SPI_HALF_SPEED, CS_SD_EXT)) 
    {
    GPU.println("SD karta neni vlozena nebo je vadna");
    } 
  else 
    {
    
  // print the type of card
  GPU.println();
  GPU.print("Typ karty: ");
  switch (card.type()) {
    case SD_CARD_TYPE_SD1:
      GPU.println("SD1");
      break;
    case SD_CARD_TYPE_SD2:
      GPU.println("SD2");
      break;
    case SD_CARD_TYPE_SDHC:
      GPU.println("SDHC");
      break;
    default:
      GPU.println("neznami");
  }

  if (!volume.init(card)) {
    GPU.println("Nebyl nalezen svazek FAT16/FAT32.\nNaformatuj kartu");
  }

  GPU.print("Clusters: ");
  GPU.println(volume.clusterCount());
  GPU.print("Blocks x Cluster: ");
  GPU.println(volume.blocksPerCluster());

  GPU.print("Total Blocks: ");
  GPU.println(volume.blocksPerCluster() * volume.clusterCount());
  GPU.println();

  uint32_t volumesize;
  GPU.print("Typ svazku: FAT");
  GPU.println(volume.fatType(), DEC);

  volumesize = volume.blocksPerCluster();    // clusters are collections of blocks
  volumesize *= volume.clusterCount();       // we'll have a lot of clusters
  volumesize /= 2;                           // SD card blocks are always 512 bytes (2 blocks are 1KB)
  GPU.print("Velikost svazku (Kb): ");
  GPU.println(volumesize);
  GPU.print("Velikost svazku (Mb): ");
  volumesize /= 1024;
  GPU.println(volumesize);
  GPU.print("Velikost svazku (Gb): ");
  GPU.println((float)volumesize / 1024.0);
  }
  digitalWrite(CS_SD_EXT, HIGH);    //nastavení CS_SD_EXT na log. 1 - SD EXT neaktivní
 }

/////////////////////////////////výpis souborů z interní SD karty////////////////////////////////////////////////////////////
void SDvypisINT()
  {    
    GPU.println();
    SD.begin(CS_SD_INT);

    File root = SD.open("/");
    printDirectory(root);
    root.close();

    digitalWrite(CS_SD_INT, HIGH);    //nastavení CS_SD_INT na log. 1 - SD INT neaktivní
    GPU.println();
   }

void printDirectory(File dir) 
{
  while (true) 
  {
    File entry = dir.openNextFile();
    if (!entry) {
      break;
    }
    GPU.println(entry.name());
    entry.close();
  }
}

/////////////////////////////////výpis souborů z externí SD karty////////////////////////////////////////////////////////////
void SDvypisEXT()
  {    
    GPU.println();
    SD.begin(CS_SD_EXT);

    File root = SD.open("/");
    printDirectory(root);
    root.close();
   
    digitalWrite(CS_SD_EXT, HIGH);    //nastavení CS_SD_EXT na log. 1 - SD EXT neaktivní
    GPU.println();
   }

//////////////////////////////////ulož na interní SD kartu////////////////////////////////////////////////////////////////////
void SDsaveINT()
  {
    GPU.println();
    SD.begin(CS_SD_INT);

    char nazev[13]; //pole pro název souboru
    int x;          //proměnná čísla řádku z příkazu
    char cislo[4];  //pole pro číslo řádku z příkazu

    nazev[0] = INklav[12];    //načtení názvu souboru do řetězce nazev
    nazev[1] = INklav[13];
    nazev[2] = INklav[14];
    nazev[3] = INklav[15];
    nazev[4] = INklav[16];
    nazev[5] = INklav[17];
    nazev[6] = INklav[18];
    nazev[7] = INklav[19];
    nazev[8] = INklav[20];
    nazev[9] = INklav[21];
    nazev[10] = INklav[22];
    nazev[11] = INklav[23];

    String jmeno = "";
    jmeno += nazev;

    File sd = SD.open(jmeno, FILE_WRITE);   //otevře nebo vytvoří soubor s názvem jmeno pro zápis

    if(sd) 
      {
        for(int a=0; a<1000; a++)    //opakuj pro všech 1000 řádků
        {
          String radek1 = BASICpole[a];    //načti řádek číslo a

          cislo[0] = radek1[0];
            
          x = atoi(cislo);  //převeď číslo z pole do int

          if(x != 0)    //pokud číslo řádku není 0
            {
              String radek = "";
              radek += radek1;
              sd.println(radek1);  //zapiš řádek  
            }
          }
         sd.close();
         GPU.println("ulozeno");
      }
      else 
      {
        GPU.println("chyba");
      }
    digitalWrite(CS_SD_INT, HIGH);    //nastavení CS_SD_INT na log. 1 - SD INT neaktivní
  }

//////////////////////////////////ulož na externí SD kartu////////////////////////////////////////////////////////////////////
void SDsaveEXT()
  {
    GPU.println();
    SD.begin(CS_SD_EXT);
    char nazev[13]; //pole pro název souboru
    int x;          //proměnná čísla řádku z příkazu
    char cislo[4];  //pole pro číslo řádku z příkazu

    nazev[0] = INklav[12];    //načtení názvu souboru do řetězce nazev
    nazev[1] = INklav[13];
    nazev[2] = INklav[14];
    nazev[3] = INklav[15];
    nazev[4] = INklav[16];
    nazev[5] = INklav[17];
    nazev[6] = INklav[18];
    nazev[7] = INklav[19];
    nazev[8] = INklav[20];
    nazev[9] = INklav[21];
    nazev[10] = INklav[22];
    nazev[11] = INklav[23];

    String jmeno = "";
    jmeno += nazev;

    File sd = SD.open(jmeno, FILE_WRITE);   //otevře nebo vytvoří soubor s názvem jmeno pro zápis

    if(sd) 
      {
        for(int a=0; a<1000; a++)    //opakuj pro všech 100 řádků
        {
          String radek1 = BASICpole[a];    //načti řádek číslo a

          cislo[0] = radek1[0];
       
          x = atoi(cislo);  //převeď číslo z pole do int
          

          if(x != 0)    //pokud číslo řádku není 0
            {
              String radek = "";
              radek += radek1;
              sd.println(radek1);  //zapiš řádek 
            }
        }
         sd.close();
         GPU.println("ulozeno");
      }
      else 
      {
        GPU.println("chyba");
      }
    digitalWrite(CS_SD_EXT, HIGH);    //nastavení CS_SD_EXT na log. 1 - SD EXT neaktivní
  }

//////////////////////////////////načti z interní SD karty////////////////////////////////////////////////////////////////////
void SDloadINT()
  {
    SD.begin(CS_SD_INT);
    
    char nazev[13];
    memset(nazev, 0, sizeof(nazev));  //vynuluj
    byte zn = 0x00;                   //načtený byte z SD
    int x=0;          //počítadlo znaků
    String nacteno;
    char nact[100];
    memset(nact, 0, sizeof(nazev));   //vynuluj
    char cislo[2];
    memset(cislo, 0, sizeof(nazev));  //vynuluj

    nazev[0] = INklav[12];    //načtení názvu souboru do řetězce nazev
    nazev[1] = INklav[13];
    nazev[2] = INklav[14];
    nazev[3] = INklav[15];
    nazev[4] = INklav[16];
    nazev[5] = INklav[17];
    nazev[6] = INklav[18];
    nazev[7] = INklav[19];
    nazev[8] = INklav[20];
    nazev[9] = INklav[21];
    nazev[10] = INklav[22];
    nazev[11] = INklav[23];

    String jmeno = "";
    jmeno += nazev;

    File sd = SD.open(jmeno);   //otevře soubor s názvem jmeno

    if(sd) 
      {
        GPU.println();
        GPU.print("nacitam soubor");

        while (sd.available())  //načítání souboru
          {
            GPU.print(".");
            zn = sd.read();       //načti byte ze souboru
            while (zn != 13 || x==100)    //opakuj dokud nenarazíš na nový řádek nebo dokud nenačteš 100 znaků
              {
                nact[x] = zn;         //ulož znak do proměnné zn
                x++;                  //zvyš počítadlo znaků
                zn = sd.read();       //načti byte ze souboru
              }
            sd.read();            //načti přebytečný byte ze souboru a zahoď ho
            x = 0;                  //vynuluj počítadlo znaků
            nacteno = nact;         //překopíruj načtená data

            if(nact[0] >= 48 && nact[0] <= 57 && nact[1] == 32)  //pokud je první znak číslo a druhý znak mezera pak
              {
                cislo[0] = nact[0];
              }
              else if(nact[0] >= 48 && nact[0] <= 57 && nact[1] >= 48 && nact[1] <= 57 && nact[2] == 32)  //pokud je 1. a 2. znak číslo a 3. mezera pak
              {
                cislo[0] = nact[0];
                cislo[1] = nact[1];
              }
              else if(nact[0] >= 48 && nact[0] <= 57 && nact[1] >= 48 && nact[1] <= 57 && nact[2] >= 48 && nact[2] <= 57 && nact[3] == 32) //pokud je 1. až 3. znak číslo a 4. mezera pak
              {
                cislo[0] = nact[0];
                cislo[1] = nact[1];
                cislo[2] = nact[2];
              }

            int a = atoi(cislo);  //převeď číslo z pole do int
        
            BASICpole[a] = nacteno;  //ulož zadaný příkaz do pole příkazů

            for (int i = 0; i < sizeof (nact); ++ i) nact [i] = (char) 0;  //vymaž pole nact
          }
    
          sd.close();
          GPU.println();
          GPU.println("soubor nacten");
      } 
      else 
      {
        GPU.println();
        GPU.println("chyba nacteni souboru");
      }

    digitalWrite(CS_SD_INT, HIGH);    //nastavení CS_SD_INT na log. 1 - SD INT neaktivní    
} 

//////////////////////////////////načti z externí SD karty////////////////////////////////////////////////////////////////////
void SDloadEXT()
{
    SD.begin(CS_SD_EXT);
    
    char nazev[13];
    memset(nazev, 0, sizeof(nazev));  //vynuluj
    byte zn = 0x00;                   //načtený byte z SD
    int x=0;          //počítadlo znaků
    String nacteno;
    char nact[100];
    memset(nact, 0, sizeof(nazev));   //vynuluj
    char cislo[2];
    memset(cislo, 0, sizeof(nazev));  //vynuluj

    nazev[0] = INklav[12];    //načtení názvu souboru do řetězce nazev
    nazev[1] = INklav[13];
    nazev[2] = INklav[14];
    nazev[3] = INklav[15];
    nazev[4] = INklav[16];
    nazev[5] = INklav[17];
    nazev[6] = INklav[18];
    nazev[7] = INklav[19];
    nazev[8] = INklav[20];
    nazev[9] = INklav[21];
    nazev[10] = INklav[22];
    nazev[11] = INklav[23];

    String jmeno = "";
    jmeno += nazev;

    File sd = SD.open(jmeno);   //otevře soubor s názvem jmeno

    if(sd) 
      {
        GPU.println();
        GPU.print("nacitam soubor");

        while (sd.available())  //načítání souboru
          {
            GPU.print(".");
            zn = sd.read();       //načti byte ze souboru
            while (zn != 13 || x==100)    //opakuj dokud nenarazíš na nový řádek nebo dokud nenačteš 100 znaků
              {
                nact[x] = zn;         //ulož znak do proměnné zn
                x++;                  //zvyš počítadlo znaků
                zn = sd.read();       //načti byte ze souboru
              }
            sd.read();            //načti přebytečný byte ze souboru a zahoď ho
            x = 0;                  //vynuluj počítadlo znaků
            nacteno = nact;         //překopíruj načtená data

            if(nact[0] >= 48 && nact[0] <= 57 && nact[1] == 32)  //pokud je první znak číslo a druhý znak mezera pak
              {
                cislo[0] = nact[0];
              }
              else if(nact[0] >= 48 && nact[0] <= 57 && nact[1] >= 48 && nact[1] <= 57 && nact[2] == 32)  //pokud je 1. a 2. znak číslo a 3. mezera pak
              {
                cislo[0] = nact[0];
                cislo[1] = nact[1];
              }
              else if(nact[0] >= 48 && nact[0] <= 57 && nact[1] >= 48 && nact[1] <= 57 && nact[2] >= 48 && nact[2] <= 57 && nact[3] == 32) //pokud je 1. až 3. znak číslo a 4. mezera pak
              {
                cislo[0] = nact[0];
                cislo[1] = nact[1];
                cislo[2] = nact[2];
              }

            int a = atoi(cislo);  //převeď číslo z pole do int
        
            BASICpole[a] = nacteno;  //ulož zadaný příkaz do pole příkazů

            for (int i = 0; i < sizeof (nact); ++ i) nact [i] = (char) 0;  //vymaž pole nact
          }
    
          sd.close();
          GPU.println();
          GPU.println("soubor nacten");
      } 
      else 
      {
        GPU.println();
        GPU.println("chyba nacteni souboru");
      }

    digitalWrite(CS_SD_EXT, HIGH);    //nastavení CS_SD_EXT na log. 1 - SD EXT neaktivní    
} 

//////////////////////////////////////smazání souboru na interní SD kartě///////////////////////////////////
void SDdelINT()
{
  GPU.println();
  SD.begin(CS_SD_INT);
  char nazev[13];

  nazev[0] = INklav[11];    //načtení názvu souboru do řetězce nazev
  nazev[1] = INklav[12];
  nazev[2] = INklav[13];
  nazev[3] = INklav[14];
  nazev[4] = INklav[15];
  nazev[5] = INklav[16];
  nazev[6] = INklav[17];
  nazev[7] = INklav[18];
  nazev[8] = INklav[19];
  nazev[9] = INklav[20];
  nazev[10] = INklav[21];
  nazev[11] = INklav[22];

  String jmeno = "";
  jmeno += nazev;

   
  if(!SD.remove(jmeno))          //smaž soubor jmeno
    {
      GPU.println("chyba mazani");
    }
    else
    {
    GPU.println("smazano");
    }

  digitalWrite(CS_SD_INT, HIGH);    //nastavení CS_SD_INT na log. 1 - SD INT neaktivní   
}

//////////////////////////////////////smazání souboru na externí SD kartě///////////////////////////////////
void SDdelEXT()
{
  GPU.println();
  SD.begin(CS_SD_EXT);
  char nazev[13];

  nazev[0] = INklav[11];    //načtení názvu souboru do řetězce nazev
  nazev[1] = INklav[12];
  nazev[2] = INklav[13];
  nazev[3] = INklav[14];
  nazev[4] = INklav[15];
  nazev[5] = INklav[16];
  nazev[6] = INklav[17];
  nazev[7] = INklav[18];
  nazev[8] = INklav[19];
  nazev[9] = INklav[20];
  nazev[10] = INklav[21];
  nazev[11] = INklav[22];

  String jmeno = "";
  jmeno += nazev;

   
  if(!SD.remove(jmeno))          //smaž soubor jmeno
    {
      GPU.println("chyba mazani");
    }
    else
    {
    GPU.println("smazano");
    }

  digitalWrite(CS_SD_EXT, HIGH);    //nastavení CS_SD_EXT na log. 1 - SD EXT neaktivní   
}

/////////////////////////////////I2C scan///////////////////////////////////////////
void i2c_scan()
  {
    GPUsmaz(); //smaž obrazovku
    GPU.println(F("I2C scan"));
    
    byte error, address;
    int nDevices;

    GPU.println(F("Skenuji..."));

    nDevices = 0;
    for(address = 1; address < 127; address++) 
    {
      Wire.beginTransmission(address);
      error = Wire.endTransmission();
    
      if(error == 0) 
        {
          GPU.print(F("I2C zarizeni nalezeno na adrese 0x"));
          if(address < 16) 
            {
            GPU.print("0");
            }
          GPU.print(address, HEX);
            if(address == 0x01)
              {
                GPU.println(" = klavesnice");
              }
              else if(address == 0x68)
              {
                GPU.println(" = RTC");
              }
              else if(address == 0x22)
              {
                GPU.println(" = LED = 34DEC");
              }
              else if(address == 0x20)
              {
                GPU.println(" = LPT = 32DEC");
              }
              else if(address == 0x21)
              {
                GPU.println(" = LPT = 33DEC");
              }
              else
              {
                GPU.println();
              }

            nDevices++;
          
        }
        else if(error == 4) 
        {
         GPU.print(F("Neznama chyba na adrese 0x"));
          if (address < 16) 
            {
              GPU.print("0");
              GPU.println(address, HEX);
            }
        }    
    }
    if(nDevices == 0)
      {
        GPU.println(F("Nenalezeno zadne I2C zarizeni"));
      }
    else
      {
        GPU.println("Hotovo");
      }
  }

////////////////////////////////////OUT////////////////////////////////////////////////////////////////////////////////
void out()
  {
    int a = INklav[4];   //načti název proměnné dat
    int b = INklav[6];   //načti název proměnné adresy

    a = a - 97;           //převeď proměnnou na pozici v poli
    b = b - 97;           //převeď proměnnou na pozici v poli

    Wire.beginTransmission(promenne[b]); //odešli na adresu v proměnné b
    Wire.write(promenne[a]);             //data v proměnné a
    Wire.endTransmission();              //konec
    GPU.println();
  }

/////////////////////////////////////IN////////////////////////////////////////////////////////////////////////////////
void in()
  {
   int a = INklav[3];   //načti název proměnné adresy
   int b = INklav[5];   //načti název proměnné dat

   a = a - 97;           //převeď proměnnou na pozici v poli
   b = b - 97;           //převeď proměnnou na pozici v poli

   Wire.requestFrom(promenne[a], 1);    //načti 1 byte z adresy a
    while(Wire.available() > 0)         //pokud jsou dostupná data
    {
      promenne[b] = Wire.read();        //načti je do proměnné b

      GPU.print("Nacteno = ");
      GPU.println(promenne[b]);
    }
  }
///////////////////////////////vytvoř proměnnou////////////////////////////////////////////////////////////////////////
void vytvorPROMENOU()
  {
    char pole[12];
    
    int x = INklav[0];    //načti název proměnné

    x = x - 97;           //převeď proměnnou na pozici v poli

    pole[0] = INklav[2];
    pole[1] = INklav[3];
    pole[2] = INklav[4];
    pole[3] = INklav[5];
    pole[4] = INklav[6];
    pole[5] = INklav[7];
    pole[6] = INklav[8];
    pole[7] = INklav[9];
    pole[8] = INklav[10];
    pole[9] = INklav[11];
    pole[10] = INklav[12];
    pole[11] = INklav[13];

    int a = atoi(pole);   //převeď číslo z pole do int
    
    promenne[x] = a;      //zapiš proměnnou do pole
    GPU.println();
         
  }

/////////////////////////////////vypiš proměnnou////////////////////////////////////////////////////////////////////
void vypisPROMENOU()
  {
    GPU.print("  ");
    GPU.print(INklav[0]);
    GPU.print("=");

    int x = INklav[0];    //načti název proměnné

    x = x - 97;           //převeď proměnnou na pozici v poli

    GPU.println(promenne[x]);
  }

///////////////////////////////////sčítání///////////////////////////////////////////////////////////////////////////
void secti()
  {
    int x = INklav[0];    //načti název proměnné pro první číslo
    int y = INklav[2];    //načti název proměnné pro druhé číslo
    int z = INklav[4];    //načti název proměnné pro součet

    x = x - 97;           //převeď proměnnou na pozici v poli
    y = y - 97;           //převeď proměnnou na pozici v poli
    z = z - 97;           //převeď proměnnou na pozici v poli

    promenne[z] = promenne[x] + promenne[y];  //sečti a ulož proměnné   
    GPU.println();
  }

///////////////////////////////////odčítání///////////////////////////////////////////////////////////////////////////
void odecti()
  {
    int x = INklav[0];    //načti název proměnné pro první číslo
    int y = INklav[2];    //načti název proměnné pro druhé číslo
    int z = INklav[4];    //načti název proměnné pro součet

    x = x - 97;           //převeď proměnnou na pozici v poli
    y = y - 97;           //převeď proměnnou na pozici v poli
    z = z - 97;           //převeď proměnnou na pozici v poli

    promenne[z] = promenne[x] - promenne[y];  //odečti a ulož proměnné   
    GPU.println();
  }

///////////////////////////////////násobení///////////////////////////////////////////////////////////////////////////
void nasob()
  {
    int x = INklav[0];    //načti název proměnné pro první číslo
    int y = INklav[2];    //načti název proměnné pro druhé číslo
    int z = INklav[4];    //načti název proměnné pro součet

    x = x - 97;           //převeď proměnnou na pozici v poli
    y = y - 97;           //převeď proměnnou na pozici v poli
    z = z - 97;           //převeď proměnnou na pozici v poli

    promenne[z] = promenne[x] * promenne[y];  //vynásob a ulož proměnné   
    GPU.println();
  }

///////////////////////////////////dělení///////////////////////////////////////////////////////////////////////////
void vydel()
  {
    int x = INklav[0];    //načti název proměnné pro první číslo
    int y = INklav[2];    //načti název proměnné pro druhé číslo
    int z = INklav[4];    //načti název proměnné pro součet

    x = x - 97;           //převeď proměnnou na pozici v poli
    y = y - 97;           //převeď proměnnou na pozici v poli
    z = z - 97;           //převeď proměnnou na pozici v poli

    promenne[z] = promenne[x] / promenne[y];  //vyděl a ulož proměnné   
    GPU.println();
  }

/////////////////////////////////////////////////AND////////////////////////////////////////////////////////////////////
void AND()
  {
    int x = INklav[0];    //načti název proměnné pro první číslo
    int y = INklav[2];    //načti název proměnné pro druhé číslo
    int z = INklav[4];    //načti název proměnné pro výsledek

    x = x - 97;           //převeď proměnnou na pozici v poli
    y = y - 97;           //převeď proměnnou na pozici v poli
    z = z - 97;           //převeď proměnnou na pozici v poli

    promenne[z] = promenne[x] & promenne[y];  //vypočti a ulož proměnné
    GPU.println();
  }

/////////////////////////////////////////////////OR//////////////////////////////////////////////////////////////////////
void OR()
  {
    int x = INklav[0];    //načti název proměnné pro první číslo
    int y = INklav[2];    //načti název proměnné pro druhé číslo
    int z = INklav[4];    //načti název proměnné pro výsledek

    x = x - 97;           //převeď proměnnou na pozici v poli
    y = y - 97;           //převeď proměnnou na pozici v poli
    z = z - 97;           //převeď proměnnou na pozici v poli

    promenne[z] = promenne[x] | promenne[y];  //vypočti a ulož proměnné
    GPU.println();
  }

/////////////////////////////////////////////////NOT - negace////////////////////////////////////////////////////////////////////
void NOT()
  {
    int x = INklav[0];    //načti název proměnné pro první číslo
    int z = INklav[2];    //načti název proměnné pro výsledek

    x = x - 97;           //převeď proměnnou na pozici v poli
    z = z - 97;           //převeď proměnnou na pozici v poli

    promenne[z] = ~ promenne[x];  //vypočti a ulož proměnné
    GPU.println();
  }

/////////////////////////////////////////////////XOR////////////////////////////////////////////////////////////////////
void XOR()
  {
    int x = INklav[0];    //načti název proměnné pro první číslo
    int y = INklav[2];    //načti název proměnné pro druhé číslo
    int z = INklav[4];    //načti název proměnné pro výsledek

    x = x - 97;           //převeď proměnnou na pozici v poli
    y = y - 97;           //převeď proměnnou na pozici v poli
    z = z - 97;           //převeď proměnnou na pozici v poli

    promenne[z] = promenne[x] ^ promenne[y];  //vypočti a ulož proměnné
    GPU.println();
  }

////////////////////////////////////////////////bitový posun vpravo///////////////////////////////////////////////////////
void posunVPRAVO()
  {
    int x = INklav[0];    //načti název proměnné pro první číslo
    int z = INklav[3];    //načti název proměnné pro výsledek
    int a = INklav[5];    //načti počet bitů posuvu

    x = x - 97;           //převeď proměnnou na pozici v poli
    z = z - 97;           //převeď proměnnou na pozici v poli  
    a = a - 48;           //převeď proměnnou na počet bitů

    promenne[z] = promenne[x] >> a;
    GPU.println();
  }

////////////////////////////////////////////////bitový posun vlevo///////////////////////////////////////////////////////
void posunVLEVO()
  {
    int x = INklav[0];    //načti název proměnné pro první číslo
    int z = INklav[3];    //načti název proměnné pro výsledek
    int a = INklav[5];    //načti počet bitů posuvu

    x = x - 97;           //převeď proměnnou na pozici v poli
    z = z - 97;           //převeď proměnnou na pozici v poli  
    a = a - 48;           //převeď proměnnou na počet bitů

    promenne[z] = promenne[x] << a;
    GPU.println();
  }

///////////////////////////////////////////podmíněný skok///////////////////////////////////////////////////////////////
void podminenySKOK()
  {
    int a;          //první proměnná 
    char b;         //porovnávací znak
    int c;          //druhá proměnná
    int d;          //číslo řádku skoku
    char cislo[4];  //pole pro číslo řádku skoku

    a = INklav[3];  //načti název proměnné    
    b = INklav[5];  //načti porovnávací znak
    c = INklav[7];  //načti název proměnné

    cislo[0] = INklav[9];
    cislo[1] = INklav[10];
    cislo[2] = INklav[11];

    d = atoi(cislo);  //převeď číslo z pole do int
    d = d-1;
    
    a = a - 97;   //převeď proměnnou na pozici v poli
    c = c - 97;   //převeď proměnnou na pozici v poli

    if(b == '<')      //pokud je porovnávací znak <
      {
        if(promenne[a] < promenne[c])     //pokud je první proměnná menší než druhá
          {
            q = d;    //proveď skok
          }
      }
    else if(b == '>') //pokud je porovnávací znak >
      {
        if(promenne[a] > promenne[c])     //pokud je první proměnná větší než druhá
          {
            q = d;    //proveď skok
          }
      }
    else if(b == '=') //pokud je porovnávací znak =
      {
        if(promenne[a] == promenne[c])    //pokud je první proměnná a druhá proměnná stejná
          {
            q = d;      //proveď skok
          }
      }
  }

/////////////////////////////////////////////výpis textu//////////////////////////////////
void print()
  {
    char text[50];

    int c = 6;
    int d = 0;

    for(int b=0; b<50; b++)  
              {
                text[d] = INklav[c];    //zkopíruj načtený řádek z proměnné klávesnice posunutý o 6 znaků příkazu do pole text
                c++;  //zvyš počítadlo
                d++;  //zvyš počítadlo
              }

     String text2 = text;

     GPU.println(text2);
     for (int i = 0; i < sizeof (text); ++ i) text [i] = (char) 0;  //vymaž pole nact
  }


///////////////////////////////////////////////cara////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void cara()
  {
    char poleX1[4];     //proměnná pro grafiku souřadnice X1
    char poleY1[4];     //proměnná pro grafiku souřadnice Y1
    char poleX2[4];     //proměnná pro grafiku souřadnice X2
    char poleY2[4];     //proměnná pro grafiku souřadnice Y2

    memset(poleX1, 0x00, sizeof(poleX1));   //vynuluj poleX1
    memset(poleY1, 0x00, sizeof(poleY1));   //vynuluj poleY1
    memset(poleX2, 0x00, sizeof(poleX2));   //vynuluj poleX2
    memset(poleY2, 0x00, sizeof(poleY2));   //vynuluj poleY2
  
    int x=5;            //počítadlo
    int a=0;            //počítadlo
    
    while(INklav[x] != 59)      //opakuj dokud nebyl načten znak ;
      {
        poleX1[a] = INklav[x];
        x++;
        a++;
      }
    x++;
    a=0;
    
    while(INklav[x] != 59)      //opakuj dokud nebyl načten znak ;
      {
        poleY1[a] = INklav[x];
        x++;
        a++;
      }
    x++;
    a=0;
    
    while(INklav[x] != 59)      //opakuj dokud nebyl načten znak ;
      {
        poleX2[a] = INklav[x];
        x++;
        a++;
      }
    x++;
    a=0;
    
    while(INklav[x] != 59)      //opakuj dokud nebyl načten znak ;
      {
        poleY2[a] = INklav[x];
        x++;
        a++;
      }
    
    GPUx1 = atoi(poleX1);   //převod char na int
    GPUy1 = atoi(poleY1);   //převod char na int
    GPUx2 = atoi(poleX2);   //převod char na int
    GPUy2 = atoi(poleY2);   //převod char na int

    GPUcara();
    GPU.println();
  }

///////////////////////////////////////////////prázdný čtverec/////////////////////////////////////////////////////////////////////
void ctverecPR()
  {
    char poleX1[4];     //proměnná pro grafiku souřadnice X1
    char poleY1[4];     //proměnná pro grafiku souřadnice Y1
    char poleX2[4];     //proměnná pro grafiku souřadnice X2
    char poleY2[4];     //proměnná pro grafiku souřadnice Y2

    memset(poleX1, 0x00, sizeof(poleX1));   //vynuluj poleX1
    memset(poleY1, 0x00, sizeof(poleY1));   //vynuluj poleY1
    memset(poleX2, 0x00, sizeof(poleX2));   //vynuluj poleX2
    memset(poleY2, 0x00, sizeof(poleY2));   //vynuluj poleY2
  
    int x=10;            //počítadlo
    int a=0;             //počítadlo
    
    while(INklav[x] != 59)      //opakuj dokud nebyl načten znak ;
      {
        poleX1[a] = INklav[x];
        x++;
        a++;
      }
    x++;
    a=0;
    
    while(INklav[x] != 59)      //opakuj dokud nebyl načten znak ;
      {
        poleY1[a] = INklav[x];
        x++;
        a++;
      }
    x++;
    a=0;
    
    while(INklav[x] != 59)      //opakuj dokud nebyl načten znak ;
      {
        poleX2[a] = INklav[x];
        x++;
        a++;
      }
    x++;
    a=0;
    
    while(INklav[x] != 59)      //opakuj dokud nebyl načten znak ;
      {
        poleY2[a] = INklav[x];
        x++;
        a++;
      }
    
    GPUx1 = atoi(poleX1);   //převod char na int
    GPUy1 = atoi(poleY1);   //převod char na int
    GPUx2 = atoi(poleX2);   //převod char na int
    GPUy2 = atoi(poleY2);   //převod char na int

    GPUctverecPR();
    GPU.println();
  }

///////////////////////////////////////////////plný čtverec/////////////////////////////////////////////////////////////////////
void ctverecPL()
  {
    char poleX1[4];     //proměnná pro grafiku souřadnice X1
    char poleY1[4];     //proměnná pro grafiku souřadnice Y1
    char poleX2[4];     //proměnná pro grafiku souřadnice X2
    char poleY2[4];     //proměnná pro grafiku souřadnice Y2
    char poleR[4];      //proměnná pro grafiku průměr kruhu R

    memset(poleX1, 0x00, sizeof(poleX1));   //vynuluj poleX1
    memset(poleY1, 0x00, sizeof(poleY1));   //vynuluj poleY1
    memset(poleX2, 0x00, sizeof(poleX2));   //vynuluj poleX2
    memset(poleY2, 0x00, sizeof(poleY2));   //vynuluj poleY2
  
    int x=10;            //počítadlo
    int a=0;            //počítadlo
    
    while(INklav[x] != 59)      //opakuj dokud nebyl načten znak ;
      {
        poleX1[a] = INklav[x];
        x++;
        a++;
      }
    x++;
    a=0;
    
    while(INklav[x] != 59)      //opakuj dokud nebyl načten znak ;
      {
        poleY1[a] = INklav[x];
        x++;
        a++;
      }
    x++;
    a=0;
    
    while(INklav[x] != 59)      //opakuj dokud nebyl načten znak ;
      {
        poleX2[a] = INklav[x];
        x++;
        a++;
      }
    x++;
    a=0;
    
    while(INklav[x] != 59)      //opakuj dokud nebyl načten znak ;
      {
        poleY2[a] = INklav[x];
        x++;
        a++;
      }
    
    GPUx1 = atoi(poleX1);   //převod char na int
    GPUy1 = atoi(poleY1);   //převod char na int
    GPUx2 = atoi(poleX2);   //převod char na int
    GPUy2 = atoi(poleY2);   //převod char na int

    GPUctverecPL();
    GPU.println();
  }

///////////////////////////////////////////////plný kruh/////////////////////////////////////////////////////////////////////
void kruhPL()
  {
    char poleX1[4];     //proměnná pro grafiku souřadnice X1
    char poleY1[4];     //proměnná pro grafiku souřadnice Y1
    char poleR[4];      //proměnná pro grafiku průměr kruhu R

    memset(poleX1, 0x00, sizeof(poleX1));   //vynuluj poleX1
    memset(poleY1, 0x00, sizeof(poleY1));   //vynuluj poleY1
    memset(poleR, 0x00, sizeof(poleR));     //vynuluj poleR

    int x=7;            //počítadlo
    int a=0;            //počítadlo
    
    while(INklav[x] != 59)      //opakuj dokud nebyl načten znak ;
      {
        poleX1[a] = INklav[x];
        x++;
        a++;
      }
    x++;
    a=0;
    
    while(INklav[x] != 59)      //opakuj dokud nebyl načten znak ;
      {
        poleY1[a] = INklav[x];
        x++;
        a++;
      }
    x++;
    a=0;
    
    while(INklav[x] != 59)      //opakuj dokud nebyl načten znak ;
      {
        poleR[a] = INklav[x];
        x++;
        a++;
      }
    
    GPUx1 = atoi(poleX1);   //převod char na int
    GPUy1 = atoi(poleY1);   //převod char na int
    GPUr = atoi(poleR);     //převod char na int

    GPUkruhPL();
    GPU.println();
  }

///////////////////////////////////////////////prázdný kruh/////////////////////////////////////////////////////////////////////
void kruhPR()
  {
    char poleX1[4];     //proměnná pro grafiku souřadnice X1
    char poleY1[4];     //proměnná pro grafiku souřadnice Y1
    char poleR[4];      //proměnná pro grafiku průměr kruhu R

    memset(poleX1, 0x00, sizeof(poleX1));   //vynuluj poleX1
    memset(poleY1, 0x00, sizeof(poleY1));   //vynuluj poleY1
    memset(poleR, 0x00, sizeof(poleR));     //vynuluj poleR
  
    int x=7;            //počítadlo
    int a=0;            //počítadlo
    
    while(INklav[x] != 59)      //opakuj dokud nebyl načten znak ;
      {
        poleX1[a] = INklav[x];
        x++;
        a++;
      }
    x++;
    a=0;
    
    while(INklav[x] != 59)      //opakuj dokud nebyl načten znak ;
      {
        poleY1[a] = INklav[x];
        x++;
        a++;
      }
    x++;
    a=0;
    
    while(INklav[x] != 59)      //opakuj dokud nebyl načten znak ;
      {
        poleR[a] = INklav[x];
        x++;
        a++;
      }
    
    GPUx1 = atoi(poleX1);   //převod char na int
    GPUy1 = atoi(poleY1);   //převod char na int
    GPUr = atoi(poleR);     //převod char na int

    GPUkruhPR();
    GPU.println();
  }

///////////////////////////////////////////////pixel/////////////////////////////////////////////////////////////////////
void pixel()
  {
    char poleX1[4];     //proměnná pro grafiku souřadnice X1
    char poleY1[4];     //proměnná pro grafiku souřadnice Y1

    memset(poleX1, 0x00, sizeof(poleX1));   //vynuluj poleX1
    memset(poleY1, 0x00, sizeof(poleY1));   //vynuluj poleY1
  
    int x=6;            //počítadlo
    int a=0;            //počítadlo
    
    while(INklav[x] != 59)      //opakuj dokud nebyl načten znak ;
      {
        poleX1[a] = INklav[x];
        x++;
        a++;
      }
    x++;
    a=0;
    
    while(INklav[x] != 59)      //opakuj dokud nebyl načten znak ;
      {
        poleY1[a] = INklav[x];
        x++;
        a++;
      }
    
    GPUx1 = atoi(poleX1);   //převod char na int
    GPUy1 = atoi(poleY1);   //převod char na int

    GPUbod();
    GPU.println();
  }

////////////////////////////podprogramy ovládání GPU////////////////////////////////////////////////////////////////////////////////////
//grafika 480x288 pixelů            text 80x24 znaků
void GPUsmaz()  //smaž obrazovku a nastav kurzor na 0,0
  {
    GPU.write(0x1B);    //ESC kód
    GPU.print("[2J");    //smaž obrazovku
    GPU.write(0x1B);    //ESC kód
    GPU.print("[f");    //nastav kurzor na 0,0
  }

void GPUctverecPL() //nakresli plný čtverec na souřadnice X1, Y1, X2 Y2
  {
    char poleX1[4];   //pole char pro souřadnice
    char poleY1[4];
    char poleX2[4];
    char poleY2[4];

    itoa(GPUx1,poleX1,10);    //převod int na char
    itoa(GPUy1,poleY1,10);
    itoa(GPUx2,poleX2,10);
    itoa(GPUy2,poleY2,10);

    GPU.write(0x1B);    //ESC kód
    GPU.print("[Z3;");
    GPU.write(poleX1);
    GPU.print(";");
    GPU.write(poleY1);
    GPU.print(";");
    GPU.write(poleX2);
    GPU.print(";");
    GPU.write(poleY2);
    GPU.print("Z");
  }

void GPUctverecPR() //nakresli prázdný čtverec na souřadnice X1, Y1, X2, Y2
  {
    char poleX1[4];   //pole char pro souřadnice
    char poleY1[4];
    char poleX2[4];
    char poleY2[4];

    itoa(GPUx1,poleX1,10);    //převod int na char
    itoa(GPUy1,poleY1,10);
    itoa(GPUx2,poleX2,10);
    itoa(GPUy2,poleY2,10);

    GPU.write(0x1B);    //ESC kód
    GPU.print("[Z2;");
    GPU.write(poleX1);
    GPU.print(";");
    GPU.write(poleY1);
    GPU.print(";");
    GPU.write(poleX2);
    GPU.print(";");
    GPU.write(poleY2);
    GPU.print("Z");
  }

void GPUkruhPL() //nakresli plný kruh na souřadnice X1, Y1 o poloměru r
  {
    char poleX1[4];
    char poleY1[4];
    char poleR[4];

    itoa(GPUx1,poleX1,10);
    itoa(GPUy1,poleY1,10);
    itoa(GPUr,poleR,10);

    GPU.write(0x1B);    //ESC kód
    GPU.print("[Z5;");
    GPU.write(poleX1);
    GPU.print(";");
    GPU.write(poleY1);
    GPU.print(";");
    GPU.write(poleR);
    GPU.print("Z");
  }

void GPUkruhPR() //nakresli prázdný kruh na souřadnice X1, Y1 o poloměru r
  {
    char poleX1[4];
    char poleY1[4];
    char poleR[4];

    itoa(GPUx1,poleX1,10);
    itoa(GPUy1,poleY1,10);
    itoa(GPUr,poleR,10);

    GPU.write(0x1B);    //ESC kód
    GPU.print("[Z4;");
    GPU.write(poleX1);
    GPU.print(";");
    GPU.write(poleY1);
    GPU.print(";");
    GPU.write(poleR);
    GPU.print("Z");
  }

void GPUcara() //nakresli čáru na souřadnice X1, Y1, X2, Y2
  {
    char poleX1[4];
    char poleY1[4];
    char poleX2[4];
    char poleY2[4];

    itoa(GPUx1,poleX1,10);
    itoa(GPUy1,poleY1,10);
    itoa(GPUx2,poleX2,10);
    itoa(GPUy2,poleY2,10);

    GPU.write(0x1B);    //ESC kód
    GPU.print("[Z1;");
    GPU.write(poleX1);
    GPU.print(";");
    GPU.write(poleY1);
    GPU.print(";");
    GPU.write(poleX2);
    GPU.print(";");
    GPU.write(poleY2);
    GPU.print("Z");
  }

void GPUbod() //nakresli bod na souřadnice X1, Y1
  {
    char poleX1[4];
    char poleY1[4];

    itoa(GPUx1,poleX1,10);
    itoa(GPUy1,poleY1,10);
    
    GPU.write(0x1B);    //ESC kód
    GPU.print("[Z1;");
    GPU.write(poleX1);
    GPU.print(";");
    GPU.write(poleY1);
    GPU.print(";");
    GPU.write(poleX1);
    GPU.print(";");
    GPU.write(poleY1);
    GPU.print("Z");
  }

////////////////////////////////////////////////podprogramy F kláves///////////////////////////////////////////////////////////////////
void F1loop()     //klávesa F1 v hlavní smyčce - nápověda
  {
    GPUsmaz();   //smaž obrazovku
    GPU.println(F("Napoveda - seznam prikazu"));
    GPU.println(F("ret - navrat do hlavni smycky"));                                                        
    GPU.println(F("xx  - ulozi prikaz do pameti prikazu, xx je cislo prikazu, pak mezera a prikaz"));
    GPU.println(F("xx= - vypise prikaz z pameti prikazu, xx je cislo prikazu"));
    GPU.println(F("list - vypise vsechny prikazy z pameti prikazu"));
    GPU.println(F("run - spusti provedeni prikazu v pameti prikazu"));
    GPU.println(F("jmp xx - skoci na prikaz cislo xx"));
    GPU.println(F("clr - smaz obrazovku"));
    GPU.println(F("delay xx - ceka zadany pocet (xx) ms"));
    GPU.println(F("uptime - zobrazi cas spusteni NEDbooku"));
    GPU.println(F("cara x1;y1;x2;y2; - nakresli caru na souradnice"));
    GPU.println(F("ctverecpr x1;y1;x2;y2; - nakresli prazdny ctverec na souradnice"));
    GPU.println(F("ctverecpl x1;y1;x2;y2; - nakresli plny ctverec na souradnice"));
    GPU.println(F("kruhpr x1;y1;r; - nakresli prazdny kruh na souradnice"));
    GPU.println(F("kruhpl x1;y1;r; - nakresli plny kruh na souradnice"));
    GPU.println(F("pixel x1;y1; - nakresli pixel na souradnice"));
    GPU.println(F("random - vypise nahodny znak"));
    GPU.println(F("delete - vymaze pamet programu"));
    GPU.println(F("time - vypise aktualni cas a datum"));
    GPU.println(F("sd info - vypise informace o SD kartách"));
    GPU.println(F("sd int ls - vypise obsah interni SD karty"));
    GPU.println(F("sd ext ls - vypise obsah externi SD karty"));
    GPU.println(F("Pro pokracovani stiskni Enter"));
    klavesnice();
    GPU.println(F("sd int load xx - nacte soubor xx z interni SD karty"));
    GPU.println(F("sd ext load xx - nacte soubor xx z externi SD karty"));
    GPU.println(F("sd int save xx - ulozi soubor xx na interni SD kartu"));
    GPU.println(F("sd ext save xx - ulozi soubor xx na externi SD kartu"));
    GPU.println(F("sd int del xx - smaze soubor xx na interni SD karte"));
    GPU.println(F("sd ext del xx - smaze soubor xx na externi SD karte"));
    GPU.println(F("x=y - zapis cele cislo y do promenne x, x je libovolne male pismeno"));
    GPU.println(F("x== - vypis obsah promenne x"));
    GPU.println(F("out x y - zapis data v promenne x na adresu v promenne y"));
    GPU.println(F("in x y - cti data z adresy v promenne x do promenne y"));
    GPU.println(F("x+y=z - secti promenne x a y a uloz do z"));
    GPU.println(F("x-y=z - odecti promenne x a y a uloz do z"));
    GPU.println(F("x*y=z - vynasob promenne x a y a uloz do z"));
    GPU.println(F("x/y=z - vydel promenne x a y a uloz do z"));
    GPU.println(F("x&y=z - AND promennych x a y a uloz do z"));
    GPU.println(F("x|y=z - OR promennych x a y a uloz do z"));
    GPU.println(F("x^y=z - XOR promennych x a y a uloz do z"));
    GPU.println(F("x~z - NOT promenne x uloz do z"));
    GPU.println(F("x>>z a - bitovy posun x o pocet bitu a vpravo a uloz do z"));
    GPU.println(F("x<<z a - bitovy posun x o pocet bitu a vlevo a uloz do z"));
    GPU.println(F("// - pokud radek zacina // jde o komentar k programu ktery nic nevykona"));
    GPU.println(F("if a b c d - podmineny skok,a=promenna,b=porovnani,c=promenna,d=radek skoku"));
    GPU.println(F("print XXX - vypise text XXX"));
    
  }

void F2loop()   //klávesa F2 v hlavní smyčce - nastavení systému
  {
    GPUsmaz();   //smaž obrazovku
    GPU.println(F("Nastaveni systemu"));
    GPU.println(F("set rtc - nastaveni RTC"));

    GPU.print("?:");
  }

void F3loop()   //klávesa F3 v hlavní smyčce - mandelbrotova množina
  {
    GPUsmaz();   //smaž obrazovku
    GPU.println("Vypocet Mandelbrotovy mnoziny");
    GPU.print("Zadej pocet iteraci(min.10): ");
    klavesnice(); //vstup z klávesnice
    char max[2];
    unsigned pocSTART;  //proměnná pro startovní čas
    unsigned pocSTOP;   //proměnná pro cílový čas
    unsigned ms;        //proměnná pro ms
    int s;              //proměnná pro s
    int s2;             //pomocná proměnná pro s
    int min;            //proměnná pro minuty
    int hod;            //proměnná pro hodiny

    max[0] = INklav[0];
    max[1] = INklav[1];
    max[2] = INklav[2];

    int maxI = atoi(max);

    int ImageHeight = 288;    //rozlišení obrazu na výšku
    int ImageWidth = 480;     //rozlišení obrazu na šířku
    double MinRe = -2.0;
    double MaxRe = 1.0;   //1.0
    double MinIm = -1.2;  //-1.2
    double MaxIm = MinIm+(MaxRe-MinRe)*ImageHeight/ImageWidth;
    double Re_factor = (MaxRe-MinRe)/(ImageWidth-1);
    double Im_factor = (MaxIm-MinIm)/(ImageHeight-1);
    unsigned MaxIterations = maxI;  //počet iterací

    GPUsmaz();   //smaž obrazovku
    pocSTART = millis();

    for(unsigned y=0; y<ImageHeight; ++y)
      {
        double c_im = MaxIm - y*Im_factor;
        for(unsigned x=0; x<ImageWidth; ++x)
          {
            double c_re = MinRe + x*Re_factor;

            double Z_re = c_re, Z_im = c_im;
            bool isInside = true;
            for(unsigned n=0; n<MaxIterations; ++n)
              {
                double Z_re2 = Z_re*Z_re, Z_im2 = Z_im*Z_im;
                if(Z_re2 + Z_im2 > 4)
                  {
                    isInside = false;
                    break;
                  }
                Z_im = 2*Z_re*Z_im + c_im;
                Z_re = Z_re2 - Z_im2 + c_re;
              }
            if(isInside) 
              { 
                delay(5);   //čekej 5ms - pro zobrazovač
                GPUx1 = x;
                GPUy1 = y;
                GPUbod();   //nakresli bod
              }
          }
      }
    pocSTOP = millis();
    ms = pocSTOP - pocSTART;

    GPU.print("pocet iteraci: ");
    GPU.println(maxI);

    GPU.print("time: ");      //vypiš čas výpočtu
    if(ms < 1000)       //pokud je čas menší než 1s
      {
        GPU.print(ms);
        GPU.println("ms");
      }
    else if(ms > 1000 && ms < 60000)      //pokud je čas víc než 1s a méně než 1 minuta
      {
        s = ms / 1000;
        GPU.print(s);
        GPU.print("s");
        ms = ms-(s*1000);
        GPU.print(ms);
        GPU.println("ms");
      }
    else if(ms > 60000 && ms < 3600000)   //pokud je čas víc než 1 minuta a méně než 1 hodina
      {
        s = ms / 1000;
        min = s / 60;
        GPU.print(min);
        GPU.print("min, ");
        s2 = min*60;
        s = s - s2;
        GPU.print(s);
        GPU.print("s, ");
        ms = ms - (min*60000)-(s*1000);
        GPU.print(ms);
        GPU.println("ms");
      }
    
    GPU.print("?:");
    klavesnice();
  }